CRCCheck off
AutoCloseWindow True
SilentInstall silent
WindowIcon off
XPSTYLE on

!define SNAME "CopyNames"

LoadLanguageFile "${NSISDIR}\Contrib\Language files\English.nlf"
VIProductVersion "0.1.0.0"
VIAddVersionKey /LANG=${LANG_ENGLISH} "ProductName" "${SNAME}"
VIAddVersionKey /LANG=${LANG_ENGLISH} "LegalCopyright" "(c)tpr 2008"
VIAddVersionKey /LANG=${LANG_ENGLISH} "FileDescription" "${SNAME}"
VIAddVersionKey /LANG=${LANG_ENGLISH} "FileVersion" "0.1"

!define CharStrip '!insertmacro CharStrip'
!define DirState `!insertmacro DirStateCall`
!define StrReplaceV4 `!insertmacro StrReplaceV4`
!define TrimText "!insertmacro TrimText"
!include "FileFunc.nsh"
!include "TextFunc.nsh"
!include 'LogicLib.nsh'
!insertmacro "GetParameters"
!insertmacro "TrimNewLines"

!define Var0 $R0
!define Var1 $R1
!define Var2 $R2
!define Var3 $R3
!define Var4 $R4
!define Var5 $R5
!define Var6 $R6
!define Var7 $R7
!define Var8 $R8

Name "${SNAME}"
Icon "${SNAME}.ico"
Caption "${SNAME}"
OutFile "..\${SNAME}.exe"
	
!macro CharStrip Char InStr OutVar
 Push '${InStr}'
 Push '${Char}'
  Call CharStrip
 Pop '${OutVar}'
!macroend

!macro StrReplaceV4 Var Replace With In
 Push ${Var1}
 Push ${Var2}
 Push `${Replace}`
 Push `${With}`
 Push `${In}`
 Call StrReplaceV4
 Pop `${Var}`
 Pop ${Var2}
 Pop ${Var1}
!macroend

!macro TrimText Text Length Char Var
Push "${Text}"
Push "${Length}"
Push "${Char}"
 Call TrimText
Pop "${Var}"
!macroend

Var parent
Var file
Var selection

Section "Main"

	IfFileExists "$EXEDIR\readme.txt" +3 0
	SetOutPath $EXEDIR
	File "readme.txt"

	${GetParameters} $1

	;check if sendto item exists (when launched from double-click)
	ShellLink::GetShortCutTarget "$SENDTO\${SNAME}.lnk"
	Pop $0
	StrCmp $0 "$EXEDIR\${SNAME}.exe" start 0

	MessageBox MB_YESNO "${SNAME} must be used via SendTo menu.$\nWould you like to install it?" IDYES 0 IDNO End
	CreateShortCut "$SENDTO\${SNAME}.lnk" "$EXEDIR\${SNAME}.exe"
	;MessageBox MB_OK "Success!$\nUse the Sendto context menu to use ${SNAME}."
	Abort
	
start:

StrCmp $1 "" 0 +3
MessageBox MB_OK "${SNAME} must be used via SendTo menu."
Abort

messagebox::show MB_DEFBUTTON4|MB_TOPMOST "What would you like to copy?" \
	"1,0" \	
	"" \
	"X:\File.ext" "File.ext" "File" "Nothing"
	
	Pop $selection

;fullpath:
	${StrReplaceV4} $1 '" "' "$\n" "$1"
	
	${CharStrip} '"' "$1" $1
	
	;copy frist 3 characters, then replace all instances of " X:\" to "$\nX:\"
	${TrimText} "$1" 3 "" "$0"
	${StrReplaceV4} $1 " $0" "$\n$0" "$1"
	
	Push $1
	
	StrCmp $selection "1" End
	
;namewithextension:
	
	;get first line only:
	Push "$\n" ;divider char
	Push "$1" ;input string
	 Call SplitFirstStrPart
	Pop $2
	
	Push $2
	 Call GetParent	;get parent directory path		
	Pop $parent
	
	${StrReplaceV4} $1 "$parent\" "" "$1"
	
	Push $1
	
	StrCmp $selection "2" End
	
;namewithoutextension:
	
	GetTempFileName $R2
	FileOpen $R3 $R2 w
	FileWrite $R3 "$1"
	FileClose $R3
	FileOpen $R3 $R2 r

	ClearErrors

	StrCpy $0 ""
	StrCpy $2 ""
	
    loop:
        FileRead $R3 $0
		${TrimNewLines} $0 $0
		StrCmp $0 "" done
		
		;check whether dir or file
			${DirState} "$parent\$0" $R0
			StrCmp $R0 "-1" file directory ;-1: directory doesn't exist
		
		file:
			StrCpy $file "1"
			Goto process
		directory:
			StrCpy $file "0"
			Goto process
		
		process:
		StrCmp $file "1" 0 +8
				Push $0
				Call GetFileExt
				Pop $3	;extension
			
			StrCmp $3 "" 0 +3
				StrCpy $2 "$2$0"
				Goto Loop
			
		StrCmp $file "1" 0 +2
			${StrReplaceV4} $0 ".$3" "" "$0"
					
				StrCmp $0 "" 0 +3
					StrCpy $2 "$2$\n.$3"
					Goto Loop
			
			StrCmp $2 "" 0 +3
				StrCpy $2 "$2$0"
				Goto Loop
			
			StrCpy $2 "$2$\n$0"
			
    Goto loop

    done:
	FileClose $R3
	
	${StrReplaceV4} $2 "$\n$\n" "$\n" "$2"
	
	Push $2

End:
	Call CopyToClipboard
	
SectionEnd

Function CopyToClipboard
Exch $0 ;input string
Push $1
Push $2
System::Call 'user32::OpenClipboard(i 0)'
System::Call 'user32::EmptyClipboard()'
StrLen $1 $0
IntOp $1 $1 + 1
System::Call 'kernel32::GlobalAlloc(i 2, i r1) i.r1'
System::Call 'kernel32::GlobalLock(i r1) i.r2'
System::Call 'kernel32::lstrcpyA(i r2, t r0)'
System::Call 'kernel32::GlobalUnlock(i r1)'
System::Call 'user32::SetClipboardData(i 1, i r1)'
System::Call 'user32::CloseClipboard()'
Pop $2
Pop $1
Pop $0
FunctionEnd

Function CharStrip
Exch $R0 #char
Exch
Exch $R1 #in string
Push $R2
Push $R3
Push $R4
 StrCpy $R2 -1
 IntOp $R2 $R2 + 1
 StrCpy $R3 $R1 1 $R2
 StrCmp $R3 "" +8
 StrCmp $R3 $R0 0 -3
  StrCpy $R3 $R1 $R2
  IntOp $R2 $R2 + 1
  StrCpy $R4 $R1 "" $R2
  StrCpy $R1 $R3$R4
  IntOp $R2 $R2 - 2
  Goto -9
  StrCpy $R0 $R1
Pop $R4
Pop $R3
Pop $R2
Pop $R1
Exch $R0
FunctionEnd

Function StrReplaceV4
Exch ${Var0} #in
Exch 1
Exch ${Var1} #with
Exch 2
Exch ${Var2} #replace
Push ${Var3}
Push ${Var4}
Push ${Var5}
Push ${Var6}
Push ${Var7}
Push ${Var8}
 
 StrCpy ${Var3} -1
 StrLen ${Var5} ${Var0}
 StrLen ${Var6} ${Var1}
 StrLen ${Var7} ${Var2}
 Loop:
  IntOp ${Var3} ${Var3} + 1
  StrCpy ${Var4} ${Var0} ${Var7} ${Var3}
  StrCmp ${Var3} ${Var5} End
  StrCmp ${Var4} ${Var2} 0 Loop
 
   StrCpy ${Var4} ${Var0} ${Var3}
   IntOp ${Var8} ${Var3} + ${Var7}
   StrCpy ${Var8} ${Var0} "" ${Var8}
   StrCpy ${Var0} ${Var4}${Var1}${Var8}
   IntOp ${Var3} ${Var3} + ${Var6}
   IntOp ${Var3} ${Var3} - 1
   IntOp ${Var5} ${Var5} - ${Var7}
   IntOp ${Var5} ${Var5} + ${Var6}
 
 Goto Loop
 End:
 
Pop ${Var8}
Pop ${Var7}
Pop ${Var6}
Pop ${Var5}
Pop ${Var4}
Pop ${Var3}
Pop ${Var2}
Pop ${Var1}
Exch ${Var0} #out
FunctionEnd

Function TrimText
 Exch $R0 ; char
 Exch
 Exch $R1 ; length
 Exch 2
 Exch $R2 ; text
 Push $R3
 Push $R4
 
 StrLen $R3 $R2
 IntCmp $R3 $R1 Done Done
 
 StrCpy $R2 $R2 $R1
 
 StrCpy $R3 0
  IntOp $R3 $R3 + 1
  StrCpy $R4 $R2 1 -$R3
  StrCmp $R4 "" Done
  StrCmp $R4 $R0 0 -3
 
  IntOp $R3 $R3 + 1
  StrCpy $R4 $R2 1 -$R3
  StrCmp $R4 "" Done
  StrCmp $R4 $R0 -3
 
  IntOp $R3 $R3 - 1
  StrCpy $R2 $R2 -$R3
  StrCpy $R2 $R2...
 
 Done:
 StrCpy $R0 $R2
 Pop $R4
 Pop $R3
 Pop $R2
 Pop $R1
 Exch $R0 ; output
FunctionEnd

Function SplitFirstStrPart
  Exch $R0
  Exch
  Exch $R1
  Push $R2
  Push $R3
  StrCpy $R3 $R1
  StrLen $R1 $R0
  IntOp $R1 $R1 + 1
  loop:
    IntOp $R1 $R1 - 1
    StrCpy $R2 $R0 1 -$R1
    StrCmp $R1 0 exit0
    StrCmp $R2 $R3 exit1 loop
  exit0:
  StrCpy $R1 ""
  Goto exit2
  exit1:
    IntOp $R1 $R1 - 1
    StrCmp $R1 0 0 +3
     StrCpy $R2 ""
     Goto +2
    StrCpy $R2 $R0 "" -$R1
    IntOp $R1 $R1 + 1
    StrCpy $R0 $R0 -$R1
    StrCpy $R1 $R2
  exit2:
  Pop $R3
  Pop $R2
  Exch $R1 ;rest
  Exch
  Exch $R0 ;first
FunctionEnd

Function GetParent
  Exch $R0
  Push $R1
  Push $R2
  Push $R3
  
  StrCpy $R1 0
  StrLen $R2 $R0
  
  loop:
    IntOp $R1 $R1 + 1
    IntCmp $R1 $R2 get 0 get
    StrCpy $R3 $R0 1 -$R1
    StrCmp $R3 "\" get
  Goto loop
  
  get:
    StrCpy $R0 $R0 -$R1
    
    Pop $R3
    Pop $R2
    Pop $R1
    Exch $R0 
FunctionEnd

Function GetFileExt
  Exch $0 ; input string
  Push $1
  Push $2
  StrCpy $1 0
  loop:
    IntOp $1 $1 - 1
    StrCpy $2 $0 1 $1
    StrCmp $2 "" empty
    StrCmp $2 "\" empty
    StrCmp $2 "." found
    Goto loop
  empty:
    StrCpy $0 ""
    goto exit
  found:
    IntOp $1 $1 + 1
    StrCpy $0 $0 "" $1
  exit:
    Pop $2
    Pop $1
    Exch $0
FunctionEnd

Function DirState
 
	Exch $0
	Push $1
	ClearErrors
 
	FindFirst $1 $0 '$0\*.*'
	IfErrors 0 +3
	StrCpy $0 -1
	goto end
	StrCmp $0 '.' 0 +4
	FindNext $1 $0
	StrCmp $0 '..' 0 +2
	FindNext $1 $0
	FindClose $1
	IfErrors 0 +3
	StrCpy $0 0
	goto end
	StrCpy $0 1
 
	end:
	Pop $1
	Exch $0
FunctionEnd